pro apply_outlier_saturation_mask,inimage,inimage_short,inimage_mask_sat_fov,inimage_short_mask_sat_fov, $
                                  IMAG=IMAG,fov_mask=fov_mask

  do_outlier_load,outlier_mask
  apply_mask,inimage,      outlier_mask,inimage_mask
  apply_mask,inimage_short,outlier_mask,inimage_short_mask

;  if ~ keyword_set(IMAG) then begin
;     check_saturation,inimage_mask,      inimage_mask_sat
;     check_saturation,inimage_short_mask,inimage_short_mask_sat

  if keyword_set(IMAG) then begin
     inimage_mask_sat=inimage_mask
     inimage_short_mask_sat=inimage_short_mask
  endif else begin
     do_correct_saturation,inimage_mask,inimage_short_mask,inimage_mask_sat,inimage_short_mask_sat
  endelse
;  endif else begin
;     inimage_mask_sat=inimage_mask
;     inimage_short_mask_sat=inimage_short_mask
;     do_correct_saturation,inimage_mask,inimage_short_mask,inimage_mask_sat,inimage_short_mask_sat
;  endelse

  if !IRC_SPECRED_OBSPARAM.slit_mode EQ 0B $
     && !IRC_SPECRED_OBSPARAM.Np_mode EQ 0B $
     && !IRC_SPECRED_PROCESSOPTION.no_fov_mask EQ 0B then begin
     do_mask_load,source_table,fov_mask

     ; shift mask image that is defiend in the imaging mode
     if ~ keyword_set(IMAG) then begin
        case !IRC_SPECRED_PROCESSTARGET.chip of
           0: mask_offset=!IRC_SPECRED_SPECEXTRACTPARAM.x_offset
           1: begin
              case !IRC_SPECRED_PROCESSTARGET.grism of
                 0: mask_offset=!IRC_SPECRED_SPECEXTRACTPARAM.x_offset
                 1: mask_offset=!IRC_SPECRED_SPECEXTRACTPARAM.x_offset
              endcase
           end
           2: mask_offset=!IRC_SPECRED_SPECEXTRACTPARAM.x_offset
        endcase
        fov_mask2=shift(fov_mask,mask_offset,0,0)
        fov_mask=fov_mask*fov_mask2
     endif
     apply_mask,inimage_mask_sat,      fov_mask,inimage_mask_sat_fov
     apply_mask,inimage_short_mask_sat,fov_mask,inimage_short_mask_sat_fov

  endif else begin              ; no FOV mask
     inimage_mask_sat_fov      =inimage_mask_sat
     inimage_short_mask_sat_fov=inimage_short_mask_sat
  endelse

  if !IRC_SPECRED_OBSPARAM.Np_mode then begin ; apply mask out of Np aperture box
                                ; update based on Oyabu kun's recommendation on 20081015
     if keyword_set(IMAG) then begin
        inimage_mask_sat_fov[0:44,*,*]=!values.f_nan
        inimage_mask_sat_fov[88:*,*,*]=!values.f_nan
        inimage_short_mask_sat_fov[0:44,*,*]=!values.f_nan
        inimage_short_mask_sat_fov[88:*,*,*]=!values.f_nan
                                ; update ends here
     endif else begin
        inimage_mask_sat_fov[0:53,*,*]=!values.f_nan
        inimage_mask_sat_fov[94:*,*,*]=!values.f_nan
        inimage_short_mask_sat_fov[0:53,*,*]=!values.f_nan
        inimage_short_mask_sat_fov[94:*,*,*]=!values.f_nan
     endelse
  endif

end
